"""rate_send_log date_format

Revision ID: 29583b8dbe50
Revises: 4074696415cd
Create Date: 2020-05-28 18:13:54.881418

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl
import imp,os

#alembic_helpers = imp.load_source('alembic_helpers', ( op.get_context().script.dir + '/alembic_helpers.py'))
#if not alembic_helpers.table_has_column('xxxx', 'yyyy'):



# revision identifiers, used by Alembic.
revision = '29583b8dbe50'
down_revision = '4074696415cd'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_index(op.f('ix_lerg_lata'), 'lerg', ['lata'], unique=False)
    op.create_index(op.f('ix_lerg_ocn'), 'lerg', ['ocn'], unique=False)
    op.add_column('rate_send_log', sa.Column('date_format', api_dnl.migration_types.ChoiceType({}), server_default=sa.text('0'), nullable=True))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('rate_send_log', 'date_format')
    op.drop_index(op.f('ix_lerg_ocn'), table_name='lerg')
    op.drop_index(op.f('ix_lerg_lata'), table_name='lerg')
    op.create_table('invoice_history',
    sa.Column('id', sa.INTEGER(), autoincrement=True, nullable=False),
    sa.Column('client_id', sa.INTEGER(), autoincrement=False, nullable=False),
    sa.Column('last_invoice_for', sa.DATE(), server_default=sa.text("('now'::text)::date"), autoincrement=False, nullable=True),
    sa.Column('last_invoice_amount', sa.NUMERIC(), autoincrement=False, nullable=True),
    sa.Column('last_invoice_period', sa.VARCHAR(length=32), autoincrement=False, nullable=True),
    sa.Column('next_invoice_date', sa.DATE(), autoincrement=False, nullable=True),
    sa.PrimaryKeyConstraint('id', name='invoice_history_pkey')
    )
    op.create_index('ix_invoice_history_last_invoice_for', 'invoice_history', ['last_invoice_for'], unique=False)
    op.create_index('ix_invoice_history_client_id', 'invoice_history', ['client_id'], unique=False)
    # ### end Alembic commands ###
"""
ADDONS
"""
def up_rec(table):
    """
    create record table and triggers for table
    :return:
    """
    sql= """
    --{table} trigger--
drop trigger IF EXISTS class4_trig_record_{table} on {table};
drop table IF EXISTS {table}_record;
DROP FUNCTION IF EXISTS class4_trigfun_record_{table}();
DROP SEQUENCE IF EXISTS {table}_record_record_id_seq;
SELECT * INTO {table}_record FROM {table} where false;
alter table {table}_record add time numeric;
alter table {table}_record add flag character(1);
alter table {table}_record add record_id integer;
alter table {table}_record alter COLUMN record_id SET NOT NULL;
create SEQUENCE {table}_record_record_id_seq;
alter table {table}_record alter COLUMN record_id SET DEFAULT nextval('{table}_record_record_id_seq'::regclass);

create function class4_trigfun_record_{table}() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;

create trigger class4_trig_record_{table} after update or insert or delete on {table} for each row execute procedure class4_trigfun_record_{table}();

create index c4_{table}_record_id_idx on {table}_record (record_id);
create index {table}_record_time_idx on {table}_record using btree (time);
    """
    connection = op.get_bind()
    connection.execute(sql.format_map(dict(table=table)))