"""resource_block ?

Revision ID: a3b385d145de
Revises: 5cff592eaeaf
Create Date: 2019-10-21 17:08:55.453859

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl
import imp,os





# revision identifiers, used by Alembic.
revision = 'a3b385d145de'
down_revision = '5cff592eaeaf'
branch_labels = None
depends_on = None


def upgrade():
    alembic_helpers = imp.load_source('alembic_helpers', ( op.get_context().script.dir + '/alembic_helpers.py'))
    if not alembic_helpers.table_has_column('cdr_report_detail', 'ingress_call_12s'):
        ### commands auto generated by Alembic - please adjust! ###
        op.add_column('cdr_report_detail', sa.Column('ingress_call_12s', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_call_18s', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_call_24s', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_call_2h', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_call_3h', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_call_4h', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_duration', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_duration_30', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_duration_6', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_inter_duration', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_inter_not_zero_calls', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_intra_duration', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_intra_not_zero_calls', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_not_zero_calls', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_not_zero_calls_30', sa.Integer(), nullable=True))
        op.add_column('cdr_report_detail', sa.Column('ingress_not_zero_calls_6', sa.Integer(), nullable=True))

    up_rec('resource_block')
    up_rec('cdr_report_detail')
    pass
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    up_rec('resource_block')
    pass
    # ### end Alembic commands ###
"""
ADDONS
"""
def up_rec(table):
    """
    create record table and triggers for table
    :return:
    """
    sql= """
    --{table} trigger--
drop trigger IF EXISTS class4_trig_record_{table} on {table};
drop table IF EXISTS {table}_record;
DROP FUNCTION IF EXISTS class4_trigfun_record_{table}();
DROP SEQUENCE IF EXISTS {table}_record_record_id_seq;
SELECT * INTO {table}_record FROM {table} where false;
alter table {table}_record add time numeric;
alter table {table}_record add flag character(1);
alter table {table}_record add record_id integer;
alter table {table}_record alter COLUMN record_id SET NOT NULL;
create SEQUENCE {table}_record_record_id_seq;
alter table {table}_record alter COLUMN record_id SET DEFAULT nextval('{table}_record_record_id_seq'::regclass);

create function class4_trigfun_record_{table}() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;

create trigger class4_trig_record_{table} after update or insert or delete on {table} for each row execute procedure class4_trigfun_record_{table}();

create index c4_{table}_record_id_idx on {table}_record (record_id);
create index {table}_record_time_idx on {table}_record using btree (time);
    """
    connection = op.get_bind()
    connection.execute(sql.format_map(dict(table=table)))